-- Author      : Nogarder
-- Create Date : 2015/3/2 19:57:02
RS.RegisterPageFunc("CustomSpell",function()
	local pairs=pairs
	local tostring=tostring
	local tonumber=tonumber
	local strfind=string.find
	local table_insert=table.insert
	local table_getn=table.getn
	local LookUpMax=200000
	local CurrentPos=0
	local DataSet={}
	local SetBy=0 --0=id, 1=name
	--
	local Localization=RS.Localization
	--
	local parent=RS.OptionsMain
	local main=RS.Template.CreateFrameWithBar(parent,nil,430,340,nil,true)
	main:SetPoint("CENTER",UIParent,"CENTER",0,0)
	main:Hide()
	local page=main.Frame
	page:SetWidth(430)
	page:SetHeight(340)
	--
	local changebutton=RS.Template.CreateButton(main.Scroll,40,20,"<>")
	changebutton:SetPoint("LEFT",main.Scroll.Title,"RIGHT",5,0)
	local byidbutton=RS.Template.CreateButton(page,70,20,"\\")
	byidbutton:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	local timeslider=RS.Template.CreateSliderEdit(page,150,50,15,1,600,0.1,180,"")
	timeslider:SetPoint("LEFT",byidbutton,"RIGHT",5,0)
	--
	local setbutton=RS.Template.CreateButton(page,20,20,">")
	setbutton:SetPoint("LEFT",timeslider,"RIGHT",15,0)
	--
	local percenttext=page:CreateFontString()
	percenttext:SetFont(GameFontNormal:GetFont())
	percenttext:SetText(0)
	percenttext:SetPoint("TOPRIGHT",page,"TOPRIGHT",-5,-2)

	--
	local CallBackFunc=function()
	end
	--
	local CurrentCDSpellID=nil
	local Text
	local Buttons={}
	for i=1,48 do
		Buttons[i]=RS.Template.CreateButton(page,30,30)
		Buttons[i]:HookScript("OnMouseUp",function(self)
			RS.RunFunc(CallBackFunc,self.Value,timeslider.Value)
		end)
		Buttons[i].Label:ClearAllPoints()
		RS.Template.SetTextSize(Buttons[i].Label,10)
		Buttons[i].Label:SetPoint("TOPLEFT",Buttons[i],"BOTTOMLEFT",-10,0)
		Buttons[i].Label:SetPoint("TOPRIGHT",Buttons[i],"BOTTOMRIGHT",10,0)
		Buttons[i]:HookScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT")
			GameTooltip:AddSpellByID(self.Value)
			GameTooltip:AddLine("Spell id"..": |cff00ff00"..self.Value)
			GameTooltip:Show()
			if(CurrentCDSpellID~=self.Value)then
				RS.Template.SetSliderEdit(timeslider,RS.CoolDown.GetSpellCoolDown(self.Value))
				CurrentCDSpellID=self.Value
			end
		end)
		local text=RS.Template.CreateText(Buttons[i])
		RS.Template.SetTextSize(text,10)
		text:SetPoint("TOPLEFT",Buttons[i],"BOTTOMLEFT",-10,-10)
		text:SetPoint("TOPRIGHT",Buttons[i],"BOTTOMRIGHT",10,-10)
		text:SetHeight(10)
		Buttons[i].NameText=text
		Buttons[i]:HookScript("OnLeave",function()
			GameTooltip:Hide()
		end)
	end
	local index=0
	for j=0,5 do
		for i=0,7 do
			index=index+1
			Buttons[index]:SetPoint("TOPLEFT",page,"TOPLEFT",15+i*50,-30-j*50)
		end
	end
	index=nil
	--
	local DataSet={}
	local SetButtons=function(offset)
		for i=1 ,48 do
			local index=offset+i
			if(DataSet[index])then
				local name, _,icon=GetSpellInfo(DataSet[index])
				Buttons[i].Texture:SetTexture(icon)
				Buttons[i].Label:SetText(DataSet[index])
				Buttons[i].NameText:SetText(name)
				Buttons[i].Value=DataSet[index]
				Buttons[i]:Show()
			else
				Buttons[i]:Hide()
			end
		end
	end
	--
	local slider=RS.Template.CreateSlider(page,0,1,1,0,3,function(slider)
		SetButtons(slider.Value)
	end,
		true)
	slider:SetPoint("TOPRIGHT",page,"TOPRIGHT",-5,-30)
	slider:SetPoint("BOTTOMRIGHT",page,"BOTTOMRIGHT",-5,5)
	slider:SetWidth(20)
	--
	main.Slider=slider
	local updateslider=function()
		local max=table_getn(DataSet)-48
		if(max<0)then
			max=0
		end
		RS.Template.SetSlider(slider,0,0,max,1,nil,true)
	end
	--
	main.Scroll:HookScript("OnMouseWheel",function(_,value)
		local value=slider.Value-floor(value*20)
		RS.Template.SetSlider(slider,value)
	end)
	--
	page:HookScript("OnUpdate",function()
		if(CurrentPos<LookUpMax)then
			for i=1,1000 do
				if(CurrentPos<LookUpMax)then
					if(SetBy==0)then
						local name=GetSpellInfo(CurrentPos)
						if(name and strfind(name,Text))then
							table_insert(DataSet,CurrentPos)
						end
					elseif(SetBy==1)then
						id=tostring(CurrentPos)
						if(strfind(id,Text) and GetSpellInfo(CurrentPos))then
							table_insert(DataSet,CurrentPos)
						end
					end
					CurrentPos=CurrentPos+1
				end
			end
			updateslider()
			SetButtons(0)
			percenttext:SetText(table_getn(DataSet).."("..floor(CurrentPos/LookUpMax*100).."%)")
		end
	end)
	--
	local CurrentByID=true
	local setbyid=function()
		SetBy=1
		DataSet={}
		CurrentPos=0
		CurrentByID=true
	end
	local setbyname=function()
		SetBy=0
		DataSet={}
		CurrentPos=0
		CurrentByID=false
	end
	byidbutton:HookScript("OnMouseUp",function()
		if(CurrentByID)then
			setbyname()
		else
			setbyid()
		end
	end)
	--
	local CheckText=function(text)
		Text=text
		if(tostring(tonumber(Text))==Text)then
			setbyid()
		else
			setbyname()
		end
		if(text=="")then
			text=Localization["InputNameOrSpellid"]
		end
		page.Scroll.Title:SetText(text)
	end

	setbutton:HookScript("OnMouseUp",function()
		if(CurrentCDSpellID)then
			RS.RunFunc(CallBackFunc,CurrentCDSpellID,timeslider.Value)
		end
	end)
	

	changebutton:HookScript("OnMouseUp",function()
		local inputbox=RS.Template.SetInputBox(changebutton,Localization["LookFor"],Text,nil)
		inputbox.CallBackFunc=CheckText
		inputbox:SetPoint("BOTTOM",changebutton,"TOP",0,5)
	end)
	--
	main.OnSetFunc=function(callbackfunc,spellid)
		CallBackFunc=callbackfunc
		if(spellid)then
			CheckText(tostring(spellid) or "")
		else
			CheckText("")
		end
	end

	--
	RS.RegisterPage("CustomSpell",main)

end)