-- Author      : Nogarder
-- Create Date : 2015/3/4 1:11:34
local Localization=RS.Localization
local Tooltips=Localization.Tooltips
local tonumber=tonumber
--
RS.Template.CreateSliderEdit=function(parent,width1,width2,height,min,max,step,value,label,tooltip,notextendable)
	local slideredit=CreateFrame("Frame",nil,parent)
	slideredit:SetWidth(width1+width2)
	slideredit:SetHeight(height)
	slideredit.Value=value
	RS.Template.SetTooltips(tooltip,slideredit,nil,nil,slideredit)
	--
	local editbox=RS.Template.CreateEditBox(slideredit,width2-1,height)
	editbox:SetPoint("RIGHT",slideredit,"RIGHT",0,0)
	RS.Template.SetTooltips(tooltip,editbox,nil,nil,slideredit)
	editbox:SetText(value)
	slideredit.EditBox=editbox
	--
	local labelmin=RS.Template.CreateText(slideredit," ",true)
	labelmin:SetPoint("LEFT",slideredit,"LEFT",0,0)
	labelmin:SetText(min)
	slideredit.LabelMin=labelmin
	--
	local labelmax=RS.Template.CreateText(slideredit," ",true)
	labelmax:SetPoint("RIGHT",editbox,"LEFT",-2,0)
	labelmax:SetText(max)
	slideredit.LabelMax=labelmax
	--
	local slider=RS.Template.CreateSlider(slideredit,min,max,step,value,1,function(self)
		if(self.UpdateByEditBox)then
			self.UpdateByEditBox=nil
		else
			editbox.UpdateBySlider=true
			slideredit.Value=self.Value
			slideredit.EditBox:SetText(self.Value)
			RS.RunFunc(slideredit.OnValueUpdateFunc,slideredit)
		end
	end)
	slider:SetPoint("LEFT",labelmin,"RIGHT",2,0)
	slider:SetPoint("RIGHT",labelmax,"LEFT",-2,0)
	slider:SetHeight(height)
	RS.Template.SetTooltips(tooltip,slider,nil,nil,slideredit)
	slideredit.Slider=slider
	--
	local label=RS.Template.CreateText(slideredit,label,true)
	label:SetPoint("BOTTOM",slideredit,"TOP",0,2)
	slideredit.Label=label
	--
	editbox:HookScript("OnCursorChanged",function()
		local slider=slideredit.Slider
		if(editbox.UpdateBySlider)then
			editbox.UpdateBySlider=nil
		else
			local value=tonumber(editbox:GetText())
			slider.UpdateByEditBox=true
			RS.Template.SetSlider(slider,value)
			slideredit.Value=slider.Value
			RS.RunFunc(slideredit.OnValueUpdateFunc,slideredit)
		end
	end)
	editbox:HookScript("OnEnterPressed",function()
		local value=tonumber(editbox:GetText())
		local slider=slideredit.Slider
		slider.UpdateByEditBox=true
		RS.Template.SetSlider(slider,value,nil,nil,nil,(not notextendable))
		slideredit.LabelMin:SetText(slideredit.Slider.Min)
		slideredit.LabelMax:SetText(slideredit.Slider.Max)
		--
		editbox:SetText(slider.Value)
	end)
	--
	return slideredit
end

RS.Template.SetSliderEdit=function(slideredit,value,min,max,step)
	RS.Template.SetSlider(slideredit.Slider,value,min,max,step,true,true)
	slideredit.EditBox.UpdateBySlider=true
	slideredit.EditBox:SetText(slideredit.Slider.Value)
	slideredit.LabelMin:SetText(slideredit.Slider.Min)
	slideredit.LabelMax:SetText(slideredit.Slider.Max)
	slideredit.Value=slideredit.Slider.Value
end
--macro for create special slider edit
RS.Template.CreateSpecialSliderEdit=function(parent,width1,width2,height,min,max,step,value,ttype,notextendable)
	return RS.Template.CreateSliderEdit(parent,width1,width2,height,min,max,step,value,Localization[ttype],Tooltips[ttype],notextendable)
end
--
--disable
RS.Template.DisableSliderEdit=function(editor)
	if(not editor.DisableLiner)then
		local texture=editor:CreateTexture(nil,"OVERLAY")
		texture:SetPoint("LEFT",editor,"LEFT",0,0)
		texture:SetPoint("RIGHT",editor,"RIGHT",0,0)
		texture:SetHeight(editor:GetHeight()/5)
		texture:SetTexture("Interface\\Addons\\NPA2_Options\\texture\\Liner")
		texture:Show()
		editor.DisableLiner=texture
	else
		editor.DisableLiner:Show()
	end
	editor:SetAlpha(0.5)
	editor:EnableMouse(false)
end
--macro for enable button
RS.Template.EnableSliderEdit=function(editor)
	if(editor.DisableLiner)then
		editor.DisableLiner:Hide()
	end
	editor:SetAlpha(1)
	editor:EnableMouse(true)
end
--
